<template>
  <div id="teacher_lecture_live_wrapper" class="bt-container" style="height: 100%; width: 1000px">
      <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
        <el-breadcrumb-item> 소그룹 토론방 </el-breadcrumb-item>
      </el-breadcrumb>
      <br/>

    <el-button v-if="speakStatus === 0" @click="startSpeak" type="primary">발언권 획득</el-button>
    <el-button v-if="speakStatus === 1" @click="endSpeak" type="danger">발언 종료</el-button>

    <span v-if="speakStatus === 2" disabled>발언권을 획득하려면, 먼저 발언중인 사람이 발언을 종료해야 합니다.</span>
    <div style="display: flex; justify-content: center">
      <video controls width="1300px" ref="speakerVideo"/>
    </div>
    <div style="display: flex; justify-content: center">
      <span> {{ speaker.name }} </span>
    </div>

    <span style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video muted controls width="100%" ref="myVideo"/>
      <span> 내 화면 </span>
    </span>

    <span v-for="user in userList" v-bind:key="user.socket_id" style="display:inline-block; width: 200px; text-align:center; position: relative">
      <video muted controls width="100%" :ref="user.socket_id"/>
      <span> {{ user.from_name }} </span>
    </span>

  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';
import LectureList from '../partials/LectureList';
import utils from '../../utils';
import lectureService from '../../services/lectureService';
import authService from '../../services/authService';
import userService from '../../services/userService';
import classService from '../../services/classService';

export default {
  name: 'SGroupRoom',
  components: {
    LectureList,
  },
  data() {
    return {
      // webRTC ***********************
      pc: [],
      offer: [],
      sender: [],
      configuration: {
        iceServers: [
          {
            urls: 'stun:stun.l.google.com:19302',
          },
        ],
      },
      hasVideo: false, // 접속자 시스템에 비디오, 오디오 여부
      hasAudio: false,
      userList: [],
      speaker: {
        socket_id: null,
        email_id: null,
        name: null,
      },
      localStream: undefined,
      heartBeat: undefined, // 발언시 하트비트
      // webRTC ***********************

      roomId: 0,     
      room: [],   
      title: '',
      count: 0,
      myId: 0,
      mytype: 0,
      myname: '',  
      authStudents: [],    
      lectureId: this.$router.currentRoute.params.lectureId,
    };
  },
  async mounted() {
    const vm = this;   
    vm.localStream = await navigator.mediaDevices.getUserMedia({
      audio: { echoCancellation: true },
      // video: { frameRate: { ideal: 3, max: 3 }, width: 75, height: 75 },
      video: { frameRate: { ideal: 20, max: 20 }, width: 1280, height: 720 },
    });
    vm.$refs.myVideo.srcObject = vm.localStream;

    console.log('from_name: utils.getNameFromJwt(), = ', utils.getNameFromJwt());

    // 입장 사실 서버에 알림
    vm.$socket.emit('DISCUSSION' , JSON.stringify({
      discussion_room_id: vm.discussionRoomId,
      from_email_id: utils.getEmailFromJwt(),
      from_name: utils.getNameFromJwt(),
    }));

    vm.sockets.subscribe('DISCUSSION', async (evt) => {
      const signal = JSON.parse(evt);

      // 이미 연결된적이 있는 유저인지 찾는다.
      let userIndex = -1;
      console.log(userIndex);
      vm.userList.forEach((element, index) => {
        // if (element.email_id === signal.from_email_id) {
        if (element.socket_id === signal.from_socket_id) {
          userIndex = index;
        }
      })
      // 만약 저장되지 않았다면, 저장하고 인덱스를 리턴한다.
      if (userIndex === -1) {
        // vm.userList.push({ email_id: signal.from_email_id });
        vm.userList.push({ socket_id: signal.from_socket_id, from_name: signal.from_name, from_email_id: signal.from_email_id });
        userIndex = vm.userList.length - 1;
      }

      if (signal.call_me || signal.offer) {
        console.log(userIndex, ': on call_me or offer (pc created)');
        vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);
        vm.localStream.getTracks().forEach(track => {
          vm.sender[userIndex] = vm.pc[userIndex].addTrack(track, vm.localStream);
          console.log('vm.sender[userIndex] = ', vm.sender[userIndex]);
        });

        const offer = await vm.pc[userIndex].createOffer();
        vm.offer[userIndex] = offer;

        if (signal.call_me) {
          console.log(userIndex, ': on call_me');
          vm.$socket.emit('DISCUSSION' , JSON.stringify({
            to_socket_id: signal.from_socket_id,
            from_email_id: utils.getEmailFromJwt(),
            from_name: utils.getNameFromJwt(),
            offer,
          }));
          console.log(userIndex, ': emit offer');
        }

        // Listen for local ICE candidates on the local RTCPeerConnection
        vm.pc[userIndex].addEventListener('icecandidate', event => {
          if (event.candidate) {
            vm.$socket.emit('DISCUSSION', JSON.stringify({
              candidate: event.candidate,
              to_socket_id: signal.from_socket_id,
              from_email_id: utils.getEmailFromJwt(),
              from_name: utils.getNameFromJwt(),
            }));
            console.log(userIndex, ': emit icecandidate');
          }
        });

        vm.pc[userIndex].addEventListener('connectionstatechange', event => {
          if (vm.pc[userIndex].connectionState === 'connected') {
            console.log(userIndex, ': peer connected!');
          }
          if (vm.pc[userIndex].connectionState === 'disconnected') {
            console.log(userIndex, ': peer disconnected!');
            vm.userList.splice(userIndex, 1);
          }
        });

        const remoteStream = new MediaStream();
        vm.$refs[signal.from_socket_id][0].srcObject = remoteStream;

        if (vm.speaker.socket_id === signal.from_socket_id) { // PeerConnection 전에 발언자 정보를 먼저 알게된 경우
          vm.$refs.speakerVideo.srcObject = remoteStream;
        }

        vm.pc[userIndex].addEventListener('track', async (event) => {
          console.log(userIndex, ': @track ☆★☆★');
          remoteStream.addTrack(event.track, remoteStream);

          if (vm.$refs.speakerVideo.srcObject) { // PeerConnection 전에 발언자 정보를 먼저 알게된 경우
            vm.$refs.speakerVideo.play();
          }
        });
      }
      if (signal.offer) {
        console.log(userIndex, ': on offer');
        vm.pc[userIndex].setRemoteDescription(new RTCSessionDescription(signal.offer));
        const answer = await vm.pc[userIndex].createAnswer();
        vm.$socket.emit('DISCUSSION', JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          from_name: utils.getNameFromJwt(),
          answer,
        }));
        console.log(userIndex, ': emit answer');
        await vm.pc[userIndex].setLocalDescription(answer);
      }
      if (signal.answer) {
        console.log(userIndex, ': on answer');
        const remoteDesc = new RTCSessionDescription(signal.answer);
        await vm.pc[userIndex].setLocalDescription(vm.offer[userIndex]);
        await vm.pc[userIndex].setRemoteDescription(remoteDesc);
      }
      if (signal.candidate) {
        try {
          await vm.pc[userIndex].addIceCandidate(signal.candidate);
          console.log(userIndex, ' : add icecandidate');
        } catch (e) {
          console.log(userIndex, ': Error adding received ice candidate');
          console.error(userIndex, ': Error adding received ice candidate', e);
        }
      }
    });

    vm.sockets.subscribe('DISCUSSION_SPEAK', async (evt) => {
      const signal = JSON.parse(evt);
      vm.speaker.socket_id = signal.speaker_socket_id;
      vm.speaker.email_id = signal.speaker_email_id;
      vm.speaker.name = signal.speaker_name;

      // 발언자가 나인지 검사
      if (utils.getEmailFromJwt() === signal.speaker_email_id) {
        vm.$refs.speakerVideo.srcObject = vm.$refs.myVideo.srcObject;
        vm.$refs.speakerVideo.play();

        vm.heartBeat = setInterval(() => { // 3초 마다 하트비트 전송
          vm.$socket.emit('DISCUSSION_SPEAK', JSON.stringify({
            heartBeat: true,
            discussion_room_id: vm.discussionRoomId,
          }));
        }, 3000);
      }

      // 이미 연결된적이 있는 유저중에 검사
      let userIndex = -1;
      vm.userList.forEach((element, index) => {
        // if (element.email_id === signal.from_email_id) {
        if (element.socket_id === signal.speaker_socket_id) {
          userIndex = index;
        }
      })
      if (userIndex !== -1) {
        vm.$refs.speakerVideo.srcObject = vm.$refs[signal.speaker_socket_id][0].srcObject;
        vm.$refs.speakerVideo.play();
      }

      // 연결 종료시 null 표시
      if (signal.speaker_socket_id === undefined || signal.speaker_socket_id === null) {
        vm.$refs.speakerVideo.srcObject = null;
        clearTimeout(vm.heartBeat); // 하트비트 해제
      }
    })
  },
  computed: {
    ...mapState('NNclass', [
      'teachingClassList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.roomId, 10);
    },
    speakStatus() {
      const vm = this;      
      if (vm.speaker.email_id === undefined || vm.speaker.email_id === null) { // 아무도 말하지 않는 중
        return 0;
      } else if (vm.speaker.email_id === utils.getEmailFromJwt()) { // 내가 말하는 중
        return 1;
      } else { // 누군가 말하는 중
        return 2;
      }
    },
  },
  methods: {
    ...mapActions('NNclass', [
      'getClass',
      'getMyClassLists',
      'deleteLectureFromClass',
    ]),
    async startSpeak() {
      const vm = this;
      vm.$socket.emit('DISCUSSION_SPEAK' , JSON.stringify({
        startSpeak: true,
        discussion_room_id: vm.discussionRoomId,
        from_email_id: utils.getEmailFromJwt(),
        from_name: utils.getNameFromJwt(),
      }));
    },
    async endSpeak() {
      const vm = this;
      vm.$socket.emit('DISCUSSION_SPEAK' , JSON.stringify({
        endSpeak: true,
        discussion_room_id: vm.discussionRoomId,
      }));
      clearTimeout(vm.heartBeat); // 하트비트 해제
    },
  },
};
</script>         